Index: branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/SubroutineDuplicater.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/SubroutineDuplicater.cs	(revision 5685)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/SubroutineDuplicater.cs	(revision 5686)
@@ -79,5 +79,25 @@
                                     select symb).SingleOrDefault();
         if (matchingInvokeSymbol != null) {
-          GrammarModifier.AddDynamicSymbol(subtree.Grammar, subtree.Symbol, duplicatedDefunBranch.FunctionName, duplicatedDefunBranch.NumberOfArguments);
+          var invokeSymbol = new InvokeFunction(duplicatedDefunBranch.FunctionName);
+          subtree.Grammar.AddSymbol(invokeSymbol);
+          subtree.Grammar.SetSubtreeCount(invokeSymbol, duplicatedDefunBranch.NumberOfArguments, duplicatedDefunBranch.NumberOfArguments);
+
+          foreach (Symbol symbol in subtree.Grammar.Symbols) {
+            if (subtree.Grammar.IsAllowedChildSymbol(symbol, matchingInvokeSymbol))
+              subtree.Grammar.AddAllowedChildSymbol(symbol, invokeSymbol);
+            else {
+              for (int i = 0; i < subtree.Grammar.GetMaximumSubtreeCount(symbol); i++)
+                if (subtree.Grammar.IsAllowedChildSymbol(symbol, matchingInvokeSymbol, i))
+                  subtree.Grammar.AddAllowedChildSymbol(symbol, matchingInvokeSymbol, i);
+            }
+          }
+
+          foreach (Symbol symbol in subtree.Grammar.GetAllowedChildSymbols(matchingInvokeSymbol))
+            if (symbol != invokeSymbol) //avoid duplicate entry invokesymbol / invokesymbol
+              subtree.Grammar.AddAllowedChildSymbol(invokeSymbol, symbol);
+          for (int i = 0; i < subtree.Grammar.GetMaximumSubtreeCount(matchingInvokeSymbol); i++) {
+            foreach (Symbol symbol in subtree.Grammar.GetAllowedChildSymbols(matchingInvokeSymbol, i).Except(subtree.Grammar.GetAllowedChildSymbols(matchingInvokeSymbol)))
+              subtree.Grammar.AddAllowedChildSymbol(invokeSymbol, symbol, i);
+          }
         }
         // in the current subtree:
Index: branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Creators/ProbabilisticTreeCreator.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Creators/ProbabilisticTreeCreator.cs	(revision 5685)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Creators/ProbabilisticTreeCreator.cs	(revision 5686)
@@ -23,5 +23,4 @@
 using System.Collections.Generic;
 using System.Linq;
-using System.Text;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -34,10 +33,8 @@
   [Item("ProbabilisticTreeCreator", "An operator that creates new symbolic expression trees with uniformly distributed length")]
   public class ProbabilisticTreeCreator : SymbolicExpressionTreeCreator,
-    ISymbolicExpressionTreeSizeConstraintOperator, ISymbolicExpressionTreeGrammarBasedOperator, ISymbolicExpressionTreeArchitectureAlteringOperator {
+    ISymbolicExpressionTreeSizeConstraintOperator, ISymbolicExpressionTreeGrammarBasedOperator {
     private const int MAX_TRIES = 100;
     private const string MaximumSymbolicExpressionTreeLengthParameterName = "MaximumSymbolicExpressionTreeLength";
     private const string MaximumSymbolicExpressionTreeDepthParameterName = "MaximumSymbolicExpressionTreeDepth";
-    private const string MaximumFunctionDefinitionsParameterName = "MaximumFunctionDefinitions";
-    private const string MaximumFunctionArgumentsParameterName = "MaximumFunctionArguments";
     private const string SymbolicExpressionTreeGrammarParameterName = "SymbolicExpressionTreeGrammar";
     #region Parameter Properties
@@ -48,12 +45,6 @@
       get { return (IValueLookupParameter<IntValue>)Parameters[MaximumSymbolicExpressionTreeDepthParameterName]; }
     }
-    public IValueLookupParameter<IntValue> MaximumFunctionDefinitionsParameter {
-      get { return (IValueLookupParameter<IntValue>)Parameters[MaximumFunctionDefinitionsParameterName]; }
-    }
-    public IValueLookupParameter<IntValue> MaximumFunctionArgumentsParameter {
-      get { return (IValueLookupParameter<IntValue>)Parameters[MaximumFunctionArgumentsParameterName]; }
-    }
-    public IValueLookupParameter<ISymbolicExpressionTreeGrammar> SymbolicExpressionTreeGrammarParameter {
-      get { return (IValueLookupParameter<ISymbolicExpressionTreeGrammar>)Parameters[SymbolicExpressionTreeGrammarParameterName]; }
+    public IValueLookupParameter<ISymbolicExpressionGrammar> SymbolicExpressionTreeGrammarParameter {
+      get { return (IValueLookupParameter<ISymbolicExpressionGrammar>)Parameters[SymbolicExpressionTreeGrammarParameterName]; }
     }
     #endregion
@@ -65,11 +56,5 @@
       get { return MaximumSymbolicExpressionTreeDepthParameter.ActualValue; }
     }
-    public IntValue MaximumFunctionDefinitions {
-      get { return MaximumFunctionDefinitionsParameter.ActualValue; }
-    }
-    public IntValue MaximumFunctionArguments {
-      get { return MaximumFunctionArgumentsParameter.ActualValue; }
-    }
-    public ISymbolicExpressionTreeGrammar SymbolicExpressionTreeGrammar {
+    public ISymbolicExpressionGrammar SymbolicExpressionTreeGrammar {
       get { return SymbolicExpressionTreeGrammarParameter.ActualValue; }
     }
@@ -83,7 +68,5 @@
       Parameters.Add(new ValueLookupParameter<IntValue>(MaximumSymbolicExpressionTreeLengthParameterName, "The maximal length (number of nodes) of the symbolic expression tree."));
       Parameters.Add(new ValueLookupParameter<IntValue>(MaximumSymbolicExpressionTreeDepthParameterName, "The maximal depth of the symbolic expression tree (a tree with one node has depth = 0)."));
-      Parameters.Add(new ValueLookupParameter<IntValue>(MaximumFunctionDefinitionsParameterName, "The maximum allowed number of automatically defined functions."));
-      Parameters.Add(new ValueLookupParameter<IntValue>(MaximumFunctionArgumentsParameterName, "The maximum allowed number of arguments of automatically defined functions."));
-      Parameters.Add(new ValueLookupParameter<ISymbolicExpressionTreeGrammar>(SymbolicExpressionTreeGrammarParameterName, "The tree grammar that defines the correct syntax of symbolic expression trees that should be created."));
+      Parameters.Add(new ValueLookupParameter<ISymbolicExpressionGrammar>(SymbolicExpressionTreeGrammarParameterName, "The tree grammar that defines the correct syntax of symbolic expression trees that should be created."));
     }
 
@@ -93,17 +76,20 @@
 
     protected override ISymbolicExpressionTree Create(IRandom random) {
-      return Create(random, SymbolicExpressionTreeGrammar, MaximumSymbolicExpressionTreeLength.Value, MaximumSymbolicExpressionTreeDepth.Value,
-        MaximumFunctionDefinitions.Value, MaximumFunctionArguments.Value);
-    }
-
-    public static ISymbolicExpressionTree Create(IRandom random, ISymbolicExpressionTreeGrammar grammar,
-      int maxTreeLength, int maxTreeDepth,
-      int maxFunctionDefinitions, int maxFunctionArguments
-      ) {
+      return Create(random, SymbolicExpressionTreeGrammar, MaximumSymbolicExpressionTreeLength.Value, MaximumSymbolicExpressionTreeDepth.Value);
+
+    }
+
+    public static ISymbolicExpressionTree Create(IRandom random, ISymbolicExpressionGrammar grammar,
+      int maxTreeLength, int maxTreeDepth) {
       SymbolicExpressionTree tree = new SymbolicExpressionTree();
-      var rootNode = (SymbolicExpressionTreeTopLevelNode)grammar.StartSymbol.CreateTreeNode();
+      var rootNode = (SymbolicExpressionTreeTopLevelNode)grammar.ProgramRootSymbol.CreateTreeNode();
       if (rootNode.HasLocalParameters) rootNode.ResetLocalParameters(random);
       rootNode.SetGrammar(new SymbolicExpressionTreeGrammar(grammar));
-      tree.Root = PTC2(random, rootNode, maxTreeLength, maxTreeDepth, maxFunctionDefinitions, maxFunctionArguments);
+      var startNode = (SymbolicExpressionTreeTopLevelNode)grammar.StartSymbol.CreateTreeNode();
+      startNode.SetGrammar(new SymbolicExpressionTreeGrammar(grammar));
+      if (startNode.HasLocalParameters) startNode.ResetLocalParameters(random);
+      rootNode.AddSubTree(startNode);
+      PTC2(random, startNode, maxTreeLength, maxTreeDepth);
+      tree.Root = rootNode;
       return tree;
     }
@@ -115,9 +101,9 @@
     }
 
-    public static ISymbolicExpressionTreeNode PTC2(IRandom random, ISymbolicExpressionTreeNode seedNode,
-      int maxLength, int maxDepth, int maxFunctionDefinitions, int maxFunctionArguments) {
+    public static void PTC2(IRandom random, ISymbolicExpressionTreeNode seedNode,
+      int maxLength, int maxDepth) {
       // tree length is limited by the grammar and by the explicit size constraints
-      int allowedMinLength = seedNode.Grammar.GetMinExpressionLength(seedNode.Symbol);
-      int allowedMaxLength = Math.Min(maxLength, seedNode.Grammar.GetMaxExpressionLength(seedNode.Symbol));
+      int allowedMinLength = seedNode.Grammar.GetMinimumExpressionLength(seedNode.Symbol);
+      int allowedMaxLength = Math.Min(maxLength, seedNode.Grammar.GetMaximumExpressionLength(seedNode.Symbol));
       int tries = 0;
       while (tries++ < MAX_TRIES) {
@@ -125,11 +111,11 @@
         int targetTreeLength;
         targetTreeLength = random.Next(allowedMinLength, allowedMaxLength + 1);
-        if (targetTreeLength <= 1 || maxDepth <= 1) return seedNode;
-
-        bool success = CreateFullTreeFromSeed(random, seedNode, seedNode.Grammar, targetTreeLength, maxDepth, maxFunctionDefinitions, maxFunctionArguments);
+        if (targetTreeLength <= 1 || maxDepth <= 1) return;
+
+        bool success = CreateFullTreeFromSeed(random, seedNode, seedNode.Grammar, targetTreeLength, maxDepth);
 
         // if successful => check constraints and return the tree if everything looks ok        
         if (success && seedNode.GetLength() <= maxLength && seedNode.GetDepth() <= maxDepth) {
-          return seedNode;
+          return;
         } else {
           // clean seedNode
@@ -142,7 +128,7 @@
 
     private static bool CreateFullTreeFromSeed(IRandom random, ISymbolicExpressionTreeNode root, ISymbolicExpressionTreeGrammar globalGrammar,
-      int targetLength, int maxDepth, int maxFunctionDefinitions, int maxFunctionArguments) {
+      int targetLength, int maxDepth) {
       try {
-        TryCreateFullTreeFromSeed(random, root, globalGrammar, targetLength, maxDepth, maxFunctionDefinitions, maxFunctionArguments);
+        TryCreateFullTreeFromSeed(random, root, globalGrammar, targetLength, maxDepth);
         return true;
       }
@@ -151,8 +137,8 @@
 
     private static void TryCreateFullTreeFromSeed(IRandom random, ISymbolicExpressionTreeNode root, ISymbolicExpressionTreeGrammar globalGrammar,
-      int targetLength, int maxDepth, int maxFunctionDefinitions, int maxFunctionArguments) {
+      int targetLength, int maxDepth) {
       List<TreeExtensionPoint> extensionPoints = new List<TreeExtensionPoint>();
       int currentLength = 1;
-      int totalListMinLength = globalGrammar.GetMinExpressionLength(root.Symbol) - 1;
+      int totalListMinLength = globalGrammar.GetMinimumExpressionLength(root.Symbol) - 1;
       int actualArity = SampleArity(random, root, targetLength);
       for (int i = 0; i < actualArity; i++) {
@@ -170,11 +156,11 @@
         int argumentIndex = nextExtension.ChildIndex;
         int extensionDepth = nextExtension.ExtensionPointDepth;
-        if (extensionDepth + parent.Grammar.GetMinExpressionDepth(parent.Symbol) >= maxDepth) {
-          ReplaceWithMinimalTree(random, root, parent, argumentIndex, maxFunctionDefinitions, maxFunctionArguments);
+        if (extensionDepth + parent.Grammar.GetMinimumExpressionDepth(parent.Symbol) >= maxDepth) {
+          ReplaceWithMinimalTree(random, root, parent, argumentIndex);
         } else {
           var allowedSymbols = (from s in parent.Grammar.Symbols
-                                where parent.Grammar.IsAllowedChild(parent.Symbol, s, argumentIndex)
-                                where parent.Grammar.GetMinExpressionDepth(s) + extensionDepth - 1 < maxDepth
-                                where parent.Grammar.GetMaxExpressionLength(s) > targetLength - totalListMinLength - currentLength
+                                where parent.Grammar.IsAllowedChildSymbol(parent.Symbol, s, argumentIndex)
+                                where parent.Grammar.GetMinimumExpressionDepth(s) + extensionDepth - 1 < maxDepth
+                                where parent.Grammar.GetMaximumExpressionLength(s) > targetLength - totalListMinLength - currentLength
                                 select s)
                                .ToList();
@@ -186,5 +172,7 @@
           parent.InsertSubTree(argumentIndex, newTree);
 
-          InitializeNewTreeNode(random, root, newTree, maxFunctionDefinitions, maxFunctionArguments);
+          var topLevelNode = newTree as SymbolicExpressionTreeTopLevelNode;
+          if (topLevelNode != null)
+            topLevelNode.SetGrammar((ISymbolicExpressionTreeGrammar)root.Grammar.Clone());
 
           currentLength++;
@@ -198,5 +186,5 @@
             extensionPoints.Add(new TreeExtensionPoint { Parent = newTree, ChildIndex = i, ExtensionPointDepth = extensionDepth + 1 });
           }
-          totalListMinLength += newTree.Grammar.GetMinExpressionLength(newTree.Symbol);
+          totalListMinLength += newTree.Grammar.GetMinimumExpressionLength(newTree.Symbol);
         }
       }
@@ -209,13 +197,13 @@
         int a = nextExtension.ChildIndex;
         int d = nextExtension.ExtensionPointDepth;
-        ReplaceWithMinimalTree(random, root, parent, a, maxFunctionDefinitions, maxFunctionArguments);
+        ReplaceWithMinimalTree(random, root, parent, a);
       }
     }
 
     private static void ReplaceWithMinimalTree(IRandom random, ISymbolicExpressionTreeNode root, ISymbolicExpressionTreeNode parent,
-      int argumentIndex, int maxFunctionDefinitions, int maxFunctionArguments) {
+      int childIndex) {
       // determine possible symbols that will lead to the smallest possible tree
-      var possibleSymbols = (from s in parent.Grammar.GetAllowedSymbols(parent.Symbol, argumentIndex)
-                             group s by parent.Grammar.GetMinExpressionLength(s) into g
+      var possibleSymbols = (from s in parent.Grammar.GetAllowedChildSymbols(parent.Symbol, childIndex)
+                             group s by parent.Grammar.GetMinimumExpressionLength(s) into g
                              orderby g.Key
                              select g).First().ToList();
@@ -224,56 +212,17 @@
       var tree = selectedSymbol.CreateTreeNode();
       if (tree.HasLocalParameters) tree.ResetLocalParameters(random);
-      parent.RemoveSubTree(argumentIndex);
-      parent.InsertSubTree(argumentIndex, tree);
-      InitializeNewTreeNode(random, root, tree, maxFunctionDefinitions, maxFunctionArguments);
-      for (int i = 0; i < tree.Grammar.GetMinSubtreeCount(tree.Symbol); i++) {
+      parent.RemoveSubTree(childIndex);
+      parent.InsertSubTree(childIndex, tree);
+
+      var topLevelNode = tree as SymbolicExpressionTreeTopLevelNode;
+      if (topLevelNode != null)
+        topLevelNode.SetGrammar((ISymbolicExpressionTreeGrammar)root.Grammar.Clone());
+
+      for (int i = 0; i < tree.Grammar.GetMinimumSubtreeCount(tree.Symbol); i++) {
         // insert a dummy sub-tree and add the pending extension to the list
         var dummy = new SymbolicExpressionTreeNode();
         tree.AddSubTree(dummy);
         // replace the just inserted dummy by recursive application
-        ReplaceWithMinimalTree(random, root, tree, i, maxFunctionDefinitions, maxFunctionArguments);
-      }
-    }
-
-    private static void InitializeNewTreeNode(IRandom random, ISymbolicExpressionTreeNode root, ISymbolicExpressionTreeNode newTree, int maxFunctionDefinitions, int maxFunctionArguments) {
-      // NB it is assumed that defuns are only allowed as children of root and nowhere else
-      // also assumes that newTree is already attached to root somewhere
-      if (IsTopLevelBranch(root, newTree)) {
-        ((SymbolicExpressionTreeTopLevelNode)newTree).SetGrammar((ISymbolicExpressionTreeGrammar)root.Grammar.Clone());
-
-        // allow invokes of existing ADFs with higher index
-        int argIndex = root.IndexOfSubTree(newTree);
-        for (int i = argIndex + 1; i < root.SubTrees.Count(); i++) {
-          var otherDefunNode = root.GetSubTree(i) as DefunTreeNode;
-          if (otherDefunNode != null) {
-            GrammarModifier.AddDynamicSymbol(newTree.Grammar, newTree.Symbol, otherDefunNode.FunctionName, otherDefunNode.NumberOfArguments);
-          }
-        }
-      }
-      if (newTree.Symbol is Defun) {
-        var defunTree = newTree as DefunTreeNode;
-        string formatString = new StringBuilder().Append('0', (int)Math.Log10(maxFunctionDefinitions * 10 - 1)).ToString(); // >= 100 functions => ###
-        var allowedNames = from index in Enumerable.Range(0, maxFunctionDefinitions)
-                           select "ADF" + index.ToString(formatString);
-        var takenNames = (from node in root.IterateNodesPrefix().OfType<DefunTreeNode>()
-                          select node.FunctionName).Distinct();
-        var remainingNames = allowedNames.Except(takenNames).ToList();
-        string functionName = remainingNames[random.Next(remainingNames.Count)];
-        // set name and number of arguments of the ADF
-        int nArgs = random.Next(maxFunctionArguments);
-        defunTree.FunctionName = functionName;
-        defunTree.NumberOfArguments = nArgs;
-        if (nArgs > 0) {
-          GrammarModifier.AddDynamicArguments(defunTree.Grammar, defunTree.Symbol, Enumerable.Range(0, nArgs));
-        }
-        // in existing branches with smaller index allow invoke of current function
-        int argIndex = root.IndexOfSubTree(newTree);
-        for (int i = 0; i < argIndex; i++) {
-          // if not dummy node
-          if (root.GetSubTree(i).Symbol != null) {
-            var existingBranch = root.GetSubTree(i);
-            GrammarModifier.AddDynamicSymbol(existingBranch.Grammar, existingBranch.Symbol, functionName, nArgs);
-          }
-        }
+        ReplaceWithMinimalTree(random, root, tree, i);
       }
     }
@@ -285,6 +234,6 @@
     private static int SampleArity(IRandom random, ISymbolicExpressionTreeNode node, int targetLength) {
       // select actualArity randomly with the constraint that the sub-trees in the minimal arity can become large enough
-      int minArity = node.Grammar.GetMinSubtreeCount(node.Symbol);
-      int maxArity = node.Grammar.GetMaxSubtreeCount(node.Symbol);
+      int minArity = node.Grammar.GetMinimumSubtreeCount(node.Symbol);
+      int maxArity = node.Grammar.GetMaximumSubtreeCount(node.Symbol);
       if (maxArity > targetLength) {
         maxArity = targetLength;
@@ -294,6 +243,6 @@
       long aggregatedLongestExpressionLength = 0;
       for (int i = 0; i < maxArity; i++) {
-        aggregatedLongestExpressionLength += (from s in node.Grammar.GetAllowedSymbols(node.Symbol, i)
-                                              select node.Grammar.GetMaxExpressionLength(s)).Max();
+        aggregatedLongestExpressionLength += (from s in node.Grammar.GetAllowedChildSymbols(node.Symbol, i)
+                                              select node.Grammar.GetMaximumExpressionLength(s)).Max();
         if (aggregatedLongestExpressionLength < targetLength) minArity = i;
         else break;
@@ -304,6 +253,6 @@
       long aggregatedShortestExpressionLength = 0;
       for (int i = 0; i < maxArity; i++) {
-        aggregatedShortestExpressionLength += (from s in node.Grammar.GetAllowedSymbols(node.Symbol, i)
-                                               select node.Grammar.GetMinExpressionLength(s)).Min();
+        aggregatedShortestExpressionLength += (from s in node.Grammar.GetAllowedChildSymbols(node.Symbol, i)
+                                               select node.Grammar.GetMinimumExpressionLength(s)).Min();
         if (aggregatedShortestExpressionLength > targetLength) {
           maxArity = i;
Index: branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Crossovers/SubtreeCrossover.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Crossovers/SubtreeCrossover.cs	(revision 5685)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Crossovers/SubtreeCrossover.cs	(revision 5686)
@@ -120,5 +120,5 @@
       // check syntax constraints of direct parent - child relation
       if (!parent.Grammar.ContainsSymbol(branch.Symbol) ||
-          !parent.Grammar.IsAllowedChild(parent.Symbol, branch.Symbol, replacedSubtreeIndex)) return false;
+          !parent.Grammar.IsAllowedChildSymbol(parent.Symbol, branch.Symbol, replacedSubtreeIndex)) return false;
 
       bool result = true;
@@ -128,6 +128,6 @@
           result &&
           parent.Grammar.ContainsSymbol(n.Symbol) &&
-          n.SubTrees.Count() >= parent.Grammar.GetMinSubtreeCount(n.Symbol) &&
-          n.SubTrees.Count() <= parent.Grammar.GetMaxSubtreeCount(n.Symbol);
+          n.SubtreesCount >= parent.Grammar.GetMinimumSubtreeCount(n.Symbol) &&
+          n.SubtreesCount <= parent.Grammar.GetMaximumSubtreeCount(n.Symbol);
       });
       return result;
@@ -136,15 +136,15 @@
     private static void SelectCrossoverPoint(IRandom random, ISymbolicExpressionTree parent0, double internalNodeProbability, int maxBranchLength, int maxBranchDepth, out ISymbolicExpressionTreeNode crossoverPoint, out int subtreeIndex) {
       if (internalNodeProbability < 0.0 || internalNodeProbability > 1.0) throw new ArgumentException("internalNodeProbability");
-      List<CrossoverPoint> internalCrossoverPoints = new List<CrossoverPoint>();
-      List<CrossoverPoint> leafCrossoverPoints = new List<CrossoverPoint>();
+      List<CutPoint> internalCrossoverPoints = new List<CutPoint>();
+      List<CutPoint> leafCrossoverPoints = new List<CutPoint>();
       parent0.Root.ForEachNodePostfix((n) => {
-        if (n.SubTrees.Count() > 0 && n != parent0.Root) {
+        if (n.SubTrees.Any() && n != parent0.Root) {
           foreach (var child in n.SubTrees) {
             if (child.GetLength() <= maxBranchLength &&
                 child.GetDepth() <= maxBranchDepth) {
-              if (child.SubTrees.Count() > 0)
-                internalCrossoverPoints.Add(new CrossoverPoint(n, child));
+              if (child.SubTrees.Any())
+                internalCrossoverPoints.Add(new CutPoint(n, child));
               else
-                leafCrossoverPoints.Add(new CrossoverPoint(n, child));
+                leafCrossoverPoints.Add(new CutPoint(n, child));
             }
           }
@@ -158,10 +158,10 @@
           var selectedCrossoverPoint = internalCrossoverPoints[random.Next(internalCrossoverPoints.Count)];
           crossoverPoint = selectedCrossoverPoint.Parent;
-          subtreeIndex = selectedCrossoverPoint.SubtreeIndex;
+          subtreeIndex = selectedCrossoverPoint.ChildIndex;
         } else {
           // otherwise select external node
           var selectedCrossoverPoint = leafCrossoverPoints[random.Next(leafCrossoverPoints.Count)];
           crossoverPoint = selectedCrossoverPoint.Parent;
-          subtreeIndex = selectedCrossoverPoint.SubtreeIndex;
+          subtreeIndex = selectedCrossoverPoint.ChildIndex;
         }
       } else if (leafCrossoverPoints.Count > 0) {
@@ -169,10 +169,10 @@
         var selectedCrossoverPoint = leafCrossoverPoints[random.Next(leafCrossoverPoints.Count)];
         crossoverPoint = selectedCrossoverPoint.Parent;
-        subtreeIndex = selectedCrossoverPoint.SubtreeIndex;
+        subtreeIndex = selectedCrossoverPoint.ChildIndex;
       } else {
         // otherwise select internal crossover point
         var selectedCrossoverPoint = internalCrossoverPoints[random.Next(internalCrossoverPoints.Count)];
         crossoverPoint = selectedCrossoverPoint.Parent;
-        subtreeIndex = selectedCrossoverPoint.SubtreeIndex;
+        subtreeIndex = selectedCrossoverPoint.ChildIndex;
       }
     }
@@ -185,5 +185,5 @@
         // select internal node if possible
         allowedInternalBranches = (from branch in branches
-                                   where branch.SubTrees.Count() > 0
+                                   where branch.SubTrees.Any()
                                    select branch).ToList();
         if (allowedInternalBranches.Count > 0) {
@@ -192,5 +192,5 @@
           // no internal nodes allowed => select leaf nodes
           allowedLeafBranches = (from branch in branches
-                                 where branch.SubTrees.Count() == 0
+                                 where !branch.SubTrees.Any()
                                  select branch).ToList();
           return allowedLeafBranches.SelectRandom(random);
@@ -199,5 +199,5 @@
         // select leaf node if possible
         allowedLeafBranches = (from branch in branches
-                               where branch.SubTrees.Count() == 0
+                               where !branch.SubTrees.Any()
                                select branch).ToList();
         if (allowedLeafBranches.Count > 0) {
@@ -205,5 +205,5 @@
         } else {
           allowedInternalBranches = (from branch in branches
-                                     where branch.SubTrees.Count() > 0
+                                     where branch.SubTrees.Any()
                                      select branch).ToList();
           return allowedInternalBranches.SelectRandom(random);
Index: branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/CutPoint.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/CutPoint.cs	(revision 5686)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/CutPoint.cs	(revision 5686)
@@ -0,0 +1,37 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding {
+  internal class CutPoint {
+    public ISymbolicExpressionTreeNode Parent { get; set; }
+    public ISymbolicExpressionTreeNode Child { get; set; }
+    private int childIndex;
+    public int ChildIndex {
+      get { return childIndex; }
+    }
+    public CutPoint(ISymbolicExpressionTreeNode parent, ISymbolicExpressionTreeNode child) {
+      this.Parent = parent;
+      this.Child = child;
+      this.childIndex = parent.IndexOfSubTree(child);
+    }
+  }
+}
Index: branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4.csproj
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4.csproj	(revision 5685)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4.csproj	(revision 5686)
@@ -124,9 +124,11 @@
     <Compile Include="Compiler\SymbolicExpressionTreeCompiler.cs" />
     <Compile Include="Interfaces\IReadOnlySymbol.cs" />
+    <Compile Include="Interfaces\ISymbolicExpressionGrammar.cs" />
+    <Compile Include="Interfaces\ISymbolicExpressionGrammarBase.cs" />
     <Compile Include="Interfaces\ISymbolicExpressionTreeGrammar.cs" />
     <Compile Include="Interfaces\Operators\ISymbolicExpressionTreeArchitectureAlteringOperator.cs" />
     <Compile Include="Interfaces\Operators\ISymbolicExpressionTreeGrammarBasedOperator.cs" />
     <Compile Include="Creators\SymbolicExpressionTreeCreator.cs" />
-    <Compile Include="Crossovers\CrossoverPoint.cs" />
+    <Compile Include="CutPoint.cs" />
     <Compile Include="Crossovers\SymbolicExpressionTreeCrossover.cs" />
     <Compile Include="Formatters\SymbolicExpressionTreeStringFormatter.cs" />
@@ -147,4 +149,6 @@
     <Compile Include="Manipulators\OnePointShaker.cs" />
     <Compile Include="Manipulators\SymbolicExpressionTreeManipulator.cs" />
+    <Compile Include="SymbolicExpressionGrammarBase.cs" />
+    <Compile Include="SymbolicExpressionGrammar.cs" />
     <Compile Include="SymbolicExpressionTreeGrammar.cs" />
     <Compile Include="SymbolicExpressionTreeTopLevelNode.cs" />
@@ -152,9 +156,5 @@
       <SubType>Code</SubType>
     </Compile>
-    <Compile Include="GlobalSymbolicExpressionGrammar.cs" />
     <Compile Include="EnumerableExtensions.cs" />
-    <Compile Include="DefaultSymbolicExpressionGrammar.cs">
-      <SubType>Code</SubType>
-    </Compile>
     <Compile Include="SymbolicExpressionTreeOperator.cs" />
     <Compile Include="SymbolicExpressionTreeTerminalNode.cs" />
